#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int maxn = 20010;
vector<int> a[maxn];
vector<int> w[maxn];
vector<int> ind[maxn];

vector<int> g[maxn];


int tin[maxn];
int u[maxn];
int up[maxn];
vector<pii> brg;
int timer = 0;
void dfsbridges(int v, int p) {
	u[v] = 2;
	tin[v] = timer++;
	up[v] = tin[v];
	forn(i, sz(g[v])) {
		int to = g[v][i];
		if (to == p) continue;
		if (u[to] == 2) up[v] = min(up[v], tin[to]);
		else if (u[to] == 0) {
			dfsbridges(to, v);
			if (up[to] == tin[to]) brg.pb(mp(v,to));
			up[v] = min(up[v], up[to]);

		}
	}
	u[v] = 1;
}

vector<int> grev[maxn];
vector<int> gind[maxn];

int ust[maxn];
int uen[maxn];

void dfs1(int v) {
	ust[v] = 1;
	forn(i, sz(g[v])) {
		int to = g[v][i];
		if (!ust[to]) {
			dfs1(to);
		}
	}
}

void dfs2(int v) {
	uen[v] = 1;
	forn(i, sz(grev[v])) {
		int to = grev[v][i];
		if (!uen[to]) dfs2(to);
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n, m; scanf("%d%d", &n, &m);
	vector<pii> edges(m);
	map<pii, pii> mind;
	forn(i, m) {
		int fr, to, W; scanf("%d%d%d", &fr, &to, &W); --fr, --to;
		if (mind.count(mp(fr,to))==0) {
			mind[mp(fr,to)] = mp(W, i);
			mind[mp(to,fr)] = mp(W, i);
		} else {
			mind[mp(fr,to)] = min(mind[mp(fr,to)], mp(W,i));
			mind[mp(to,fr)] = min(mind[mp(to,fr)], mp(W,i));
		}
		edges[i] = mp(fr, to);
		a[fr].pb(to);
		w[fr].pb(W);
		ind[fr].pb(i);
		a[to].pb(fr);
		w[to].pb(W);
		ind[to].pb(i);
	}
	const ll cinf = 1e18;
	vector<ll> d(n, cinf);
	d[0] = 0;
	priority_queue<pair<ll, int> > q;
	q.push(mp(-d[0], 0));
	while (!q.empty()) {
		int curv = q.top().Y;
		ll curd = -q.top().X;
		q.pop();
		if (curd != d[curv]) continue;
		forn(i, sz(a[curv])) {
			int to = a[curv][i];
			ll tow = curd+w[curv][i];
			if (d[to] > tow) {
				d[to] = tow;
				q.push(mp(-d[to], to));
			}
		}
	}
	vector<int> v;
	forn(i, n) forn(j, sz(a[i])) {
		int fr = i;
		int to = a[i][j];
		if (d[to] == d[fr]+w[i][j]) {
			v.pb(ind[i][j]);
		}
	}
	sort(ALL(v));
	v.erase(unique(ALL(v)), v.end());

	forn(ii, sz(v)) {
		int fr = edges[v[ii]].X;
		int to = edges[v[ii]].Y;
		if (d[fr] > d[to]) swap(fr, to);
		g[fr].pb(to);
		grev[to].pb(fr);
	}

	dfs1(0);
	dfs2(n-1);

	forn(i, n) g[i].clear();

	map<pii, int> mm;
	forn(ii, sz(v)) {
		int fr = edges[v[ii]].X;
		int to = edges[v[ii]].Y;
		if (fr > to) swap(fr, to);
		mm[mp(fr, to)]++;
		g[fr].pb(to);
		g[to].pb(fr);
	}

	dfsbridges(0, -1);
	vector<int> ans;
	forn(ii, sz(brg)) {
		int fr = brg[ii].X;
		int to = brg[ii].Y;
		if (d[fr] > d[to]) swap(fr, to);
		if (mm[mp(fr,to)] == 1 && (ust[fr] && uen[to])) ans.pb(mind[mp(fr,to)].Y);
	}
	sort(ALL(ans));
	ans.erase(unique(ALL(ans)), ans.end());
	printf("%d\n", sz(ans));
	forn(i, sz(ans)) printf("%d ", ans[i]+1);
	printf("\n");

	return 0;
}
