#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;
const int INF = 1e9;
struct edge{
	int a,b,cap,flow;
};
vector<edge> e;
vector<vector<int> > vv,rv,vv1;
void add_edge(int a,int b,int cap){
	int l = L(e);
	edge e1 = {a,b,cap,0};
	edge e2 = {b,a,0,0};
	vv[a].pb(l++);
	vv[b].pb(l++);
	e.pb(e1);
	e.pb(e2);
}
const int maxn = 1010;
int used[maxn];
int s,t;
int W;
int gl;
bool dfs(int v){
	if(v==t)
		return true;
	if(used[v]>=gl)
		return false;
	used[v] = gl;
	for(int i = 0;i < L(vv[v]);i++){
		int to = vv[v][i];
		if(e[to].cap - e[to].flow >= W && dfs(e[to].b)){
			e[to].flow+=W;
			e[to^1].flow-=W;
			return true;
		}
	}
	return false;
}

int solve(){
	W = 1e3;
	ll ans = 0;
	while(W){
		while(true){
			gl++;
			if(dfs(s))
				ans+=W;
			else
				break;
		}
		W/=2;
	}
	return ans;
}
int trash[maxn];
bool bad[maxn];
void dfs2(int v);
void dfs3(int v){
	bad[v] = true;
	for(int i = 0;i < L(vv[v]);i++){
		int to = vv[v][i];
		if(e[to].flow>0){
			int b = e[to].b;
			if(!bad[b]){
				dfs3(b);
				dfs2(b);
			}
		}
	}
}
void dfs2(int v){
	bad[v] = true;
	dfs3(v);
	for(int i = 0;i < L(rv[v]);i++){
		int to = rv[v][i];
		if(!bad[to]){
			dfs2(to);
		}
	}
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n,m,k;
	cin >> n >> m >> k;
	s = 0;
	t = n+1;
	vv.resize(t+1);
	vv1.resize(t+1);
	int sum = 0;
	for(int i = 1;i <= n;i++){
		int c;
		cin >> c;
		if(c<0){
			add_edge(i,t,-c);
		}
		else{
			add_edge(s,i,c);
			sum+=c;
		}
	}
	for(int i = 1;i <=n;i++)
		cin >> trash[i];
	rv.resize(t+1);

	for(int i = 0;i < m;i++){
		int a,b;
		cin >> a >> b;
		add_edge(a,b,INF);
		rv[b].pb(a);
	}
	int s = sum-solve();
	cout << s << endl;
	gl++;
	for(int i = 0;i < L(e);i+=2){
		int a = e[i].a;
		int b = e[i].b;
		if(b==t){
			if(e[i].flow < e[i].cap)
				dfs2(a);
		}
	}
	vector<int> ans;
	for(int i = 1;i <= n;i++){
		if(!bad[i]){
			ans.pb(i);
		}
	}
	cout << L(ans) << endl;
	for(int i = 0;i < L(ans);i++)
		cout << ans[i] << " ";
	return 0;
}
