#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int maxn = 110;
int p[maxn];
int findset(int x) {
	if (x == p[x]) return x;
	return p[x] = findset(p[x]);
}

bool unite(int x, int y) {
	x = findset(x);
	y = findset(y);
	if (x == y) return false;
	if (rand()&1) swap(x, y);
	p[y] = x;
	return true;
}

int d[maxn][maxn];

const int cinf = 1000000010;

vector<pii> a[maxn];

int calc(int fr, int to, int par) {
	if (fr == to) return cinf;
	forn(i, sz(a[fr])) {
		int tov = a[fr][i].X;
		if (tov == par) continue;
		int tow = a[fr][i].Y;
		int rr = calc(tov, to, fr);
		if (rr >= 0) return min(rr, tow);
	}
	return -cinf;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int n; scanf("%d", &n);
	forn(i, n) p[i] = i;
	vector<pair<int, pii> > edges;
	forn(i, n) forn(j, n) {
		int w; scanf("%d", &w);
		d[i][j] = w;
		if (i < j) edges.pb(mp(w, mp(i, j)));
	}
	sort(ALL(edges));
	reverse(ALL(edges));
	vector<pair<int, pii> > ans;
	forn(i, sz(edges)) {
		if (unite(edges[i].Y.X, edges[i].Y.Y)) ans.pb(edges[i]);
	}
	forn(i, sz(ans)) a[ans[i].Y.X].pb(mp(ans[i].Y.Y, ans[i].X)), a[ans[i].Y.Y].pb(mp(ans[i].Y.X, ans[i].X));
	forn(i, n) forn(j, i) {
		int r1 = calc(i, j, -1);
		if (r1 != d[i][j]) printf("NO\n"), exit(0);
	}

	printf("YES\n");
	printf("%d\n", sz(ans));
	forn(i, sz(ans)) printf("%d %d %d\n", ans[i].Y.X+1, ans[i].Y.Y+1, ans[i].X);
	return 0;
}
