#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 8002

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = 1<<17;
const int inf = 1<<30;

int n;
vector <int> g[MAXN];
int c[MAXN];
int cc;
int pl[MAXN];
int pr[MAXN];
int was[MAXN], it;
bool used[MAXN];
int color[MAXN], colors;
vector<int> top;
vector<int> e[MAXN], rev[MAXN];

bool kuhn(int v) {
	if (was[v] != cc) return 0;
	was[v] = cc;
	for (int i = 0; i < sz(g[v]); i++) {
		int to = g[v][i];
		if (pr[to] == -1 || kuhn(pr[to])) {
			pr[to] = v;
			pl[v] = to;
			return 1;
		}
	}
	return 0;
}

void dfs(int v) {
	used[v] = 1;
	for (int i = 0; i < sz(e[v]); i++) {
		int to = e[v][i];
		if (used[to]) continue;
		dfs(to);
	}
	top.pb(v);
}

void dfs2(int v, int c) {
	color[v] = c;
	for (int i = 0; i < sz(rev[v]); i++) {
		int to = rev[v][i];
		if (!color[to])
			dfs2(to, c);
	}
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		int k;
		scanf("%d", &k);
		g[i].resize(k);
		for (int j = 0; j < k; ++j)
		{
			scanf("%d", &g[i][j]);
			--g[i][j];
		}
	}

/*	for (int i = 0; i < n; ++i)
		pl[i] = pr[i] = -1;


	for (int i = 0; i < n; ++i)
		for (int j = 0; j < sz(g[i]); ++j)
		{
			int v2 = g[i][j];
			if (pr[v2] == -1)
			{
				pl[i] = v2;
				pr[v2] = i;
				break;
			}
		}

	for (int i = 0; i < n; ++i)
	{
		if (pl[i] != -1) continue;
		++cc;
		if (!kuhn(i))
		{
			for (int j = 0; j < n; ++j)
				puts("0");
			return 0;
		}
	}

	for (int i = 0; i < n; i++)
		cout << pl[i] << " ";
	return 0;*/

	for (int i = 0; i < n; i++) {
		scanf("%d", pl+i);
		pl[i]--;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < sz(g[i]); j++) {
			int to = g[i][j];
			if (pl[i] == to) {
				e[to+n].pb(i);
				rev[i].pb(to+n);
			}
				e[i].pb(to+n);
				rev[to+n].pb(i);
		}

	for (int i = 0; i < n+n; i++)
		if (!used[i]) dfs(i);

	for (int i = 1; i <= n+n; i++) {
		int v = top[n+n-i];
		if (!color[v]) {
			dfs2(v, ++colors);
		}
	}

	for (int i = 0; i < n; i++) {
		vector<int> ans;
		for (int j = 0; j < sz(g[i]); j++) {
		 	int to = g[i][j];
		 	if (color[i] == color[to+n]) {
		 		ans.pb(to+1);
		 	}
		}
		printf("%d ", sz(ans));
		for (int j = 0; j < sz(ans); j++)
			printf("%d ", ans[j]);
		printf("\n");
	}

	return 0;
}
