#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = 1<<17;
const int inf = (int)2e9+100;

int d[N], up[N], n, m;
vector<pii> e[N];
vector<int> id[N];
bool ans[N];
set<pii> s;
int dist[N], d1[N], d2[N];

void dfs(int v, int pr, int lvl) {
	d[v] = up[v] = lvl;
	for (int i = 0; i < sz(e[v]); i++) {
		int to = e[v][i].first;
		int cost = e[v][i].second;
		int eid = id[v][i];
		if (to == pr) continue;
		if (d[to] == 0) {
			if (0ll + d1[v] + cost + d2[to] != d1[n]) continue;
			dfs(to, v, lvl + 1);
			up[v] = min(up[v], up[to]);
			if (up[to] > d[v]) {
				ans[eid] = 1;
			}
		} else {
			if (0ll + d1[to] + cost + d2[v] != d1[n]) continue;
			up[v] = min(up[v], d[to]);
		}
	}
}

void upd(int v, int w) {
	if (dist[v] <= w) return;
	s.erase(mp(dist[v], v));
	s.insert(mp(dist[v]=w, v));
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d %d", &n, &m);
	for (int i = 1; i <= m; i++) {
		int a, b, c;
		scanf("%d %d %d", &a, &b, &c);
		e[a].pb(mp(b, c)); id[a].pb(i);
		e[b].pb(mp(a, c)); id[b].pb(i);
	}

	for (int i = 1; i <= n; i++)
		dist[i] = inf;
	upd(1, 0);
	while (!s.empty()) {
		int v = s.begin()->second;
		int w = s.begin()->first;
		s.erase(s.begin());
		for (int i = 0; i < sz(e[v]); i++) {
			int to = e[v][i].first;
			int cost = e[v][i].second;
			upd(to, (int)min(0ll + w + cost, 0ll+inf));
		}
	}
	for (int i = 1; i <= n; i++)
		d1[i] = dist[i];

	for (int i = 1; i <= n; i++)
		dist[i] = inf;
	upd(n, 0);
	while (!s.empty()) {
		int v = s.begin()->second;
		int w = s.begin()->first;
		s.erase(s.begin());
		for (int i = 0; i < sz(e[v]); i++) {
			int to = e[v][i].first;
			int cost = e[v][i].second;
			upd(to, (int)min(0ll + w + cost, 0ll+inf));
		}
	}
	for (int i = 1; i <= n; i++)
		d2[i] = dist[i];

	dfs(1, 0, 1);
	int cnt = 0;
	for (int i = 1; i <= m; i++)
		cnt += ans[i];
	printf("%d\n", cnt);
	for (int i = 1; i <= m; i++)
		if (ans[i])
			printf("%d ", i);
	return 0;
}
