#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;
const int Nodes = N*100;

int root, nodes, n, m;
int t[Nodes], lch[Nodes], pr[Nodes], rch[Nodes], ind[Nodes];
pii a[N];

int get(int v, int l, int r, int L, int R) {
	if (r < L || R < l) return -1;

	if (t[v] == 1) return -1;

	if (l == r) {
		ind[v] = l;
		return v;
	}

	int mid = (l + r) / 2;

	if (lch[v] == 0) {
		lch[v] = ++nodes;
		pr[nodes] = v;
	}

	int tmp = get(lch[v], l, mid, L, R);
	if (tmp != -1) return tmp;
	
	if (rch[v] == 0) {
		rch[v] = ++nodes;
		pr[nodes] = v;
	}
	return get(rch[v], mid+1, r, L, R);
}

void upd(int v) {
	t[v] = 1;
	while (pr[v]) {
		v = pr[v];
		t[v] = min(t[lch[v]], t[rch[v]]);
	}
}

void solve() {
	scanf("%d %d", &m, &n);
	for (int i = 0; i < n; i++) {
		scanf("%d %d", &a[i].left, &a[i].right);
	}
	sort(a, a + n);
	nodes = 0;
	ms(t, 0);
	ms(pr, 0);
	ms(lch, 0);
	ms(rch, 0);
	root = ++nodes;
	int loh = -1;
	for (int i = 0; i < n; i++) {
		int v;
		if (a[i].left <= a[i].right) {
			v = get(root, 0, N-1, a[i].left, a[i].right);
		} else {
			v = get(root, 0, N-1, a[i].left, m-1);
			if (v == -1) v = get(root, 0, N-1, 0, a[i].right);
		}
		if (v == -1) {
			loh = i;
			break;
		}
		upd(v);
	}
	if (loh == -1) {
		puts("YES");
		return;
	}
	int i = loh;
	while (1) {
		int j = (i-1+n)%n;
		if (a[j] != a[i]) break;
		i = j;
		if (i == loh) break;
	}
	loh = i;
	int loh2 = -1;
	for (int k = 0; k < n; k++) {
		int v;
		int i = (loh + k) % n;
		if (a[i].left <= a[i].right) {
			v = get(root, 0, N-1, a[i].left, a[i].right);
		} else {
			v = get(root, 0, N-1, a[i].left, m-1);
			if (v == -1) v = get(root, 0, N-1, 0, a[i].right);
		}
		if (v == -1) {
			loh2 = i;
			break;
		}
		upd(v);
	}
	if (loh2 == -1) {
		puts("YES");
		return;
	}
	puts("NO");
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);
	while (t--) {
		solve();
	}

	return 0;
}
