#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "d"

#define M 20200
#define INF 2000200200

int n, m;
vector<int> g[M], w[M], num[M];

void read()
{
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int x, y, we;
		cin >> x >> y >> we;
		g[x].push_back(y);
		g[y].push_back(x);
		w[x].push_back(we);
		w[y].push_back(we);
		
		num[x].push_back(i + 1);
		num[y].push_back(i + 1);
	}
}

bool used[M];
priority_queue< pair<int, int>, vector< pair<int, int> >, greater< pair<int, int> > > q;

void relax(int *d, int v)
{
	used[v] = true;
	for (size_t i = 0; i < g[v].size(); ++i)
	{
		int to = g[v][i];
		int we = w[v][i];
		if (d[to] > d[v] + we)
		{
			d[to] = d[v] + we;
			q.push(make_pair(d[to], to));
		}
	}
}

void dijkstra(int st, int *d)
{
	fill(used, used + M, false);
	fill(d, d + M, INF);
	d[st] = 0;
	q.push(make_pair(d[st], st));
	while (!q.empty())
	{
		int v = q.top().second;
		q.pop();
		if (used[v])
			continue;
		relax(d, v);
	}
}

int a[M], b[M];
int p[M], s[M];
int out[M];
vector<int> ans;

bool cmp(const int &x, const int &y)
{
	return a[x] < a[y];
}

void kill()
{
	dijkstra(1, a);
	dijkstra(n, b);
	
	
//	for (int i = 1; i <= n; ++i)
//		cerr << a[i] << " ";
//	cerr << "\n";
//	for (int i = 1; i <= n; ++i)
//		cerr << b[i] << " ";
//	cerr << "\n";
//	
	for (int i = 1; i <= n; ++i)
		p[i] = i;
	
	sort(p + 1, p + (n + 1), cmp);
	
	for (int i = 1; i <= n; ++i)
		for (size_t j = 0; j < g[i].size(); ++j)
		{
			int x = i;
			int y = g[i][j];
			int we = w[i][j];
			if (a[x] + we == a[y] && b[y] + we == b[x])
			{
				++s[x], --s[y];
				out[x] = num[i][j];
			}
		}
	
	int sum = 0;
	for (int i = 1; i <= n; ++i)
	{
		int x = p[i];
		if ((long long) a[x] + b[x] != a[n])
			continue;
		sum += s[x];
		if (sum == 1)
		{
			ans.push_back(out[x]);
			//cerr << x << "!\n";
		}
		if (x == n)
			break;
	}
	
	sort(ans.begin(), ans.end());
	cout << ans.size() << "\n";
	for (int x : ans)
		cout << x << " ";
	cout << "\n";
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	read();
	kill();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
