#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "i"

const int maxn = 100;
const int maxm = maxn * maxn / 2;

vector<int> g[maxm];
int used[maxm], connect[maxm], gto[maxm], cnt[maxm];
int timer = 0;
int n, m;

bool kuhn(int v)
{
	if (used[v] == timer) return false;
	used[v] = timer;
	for (int to : g[v])
		if (connect[to] == -1 || kuhn(connect[to]))
		{
			gto[v] = to;
			connect[to] = v;
			return true;
		}
	return false;
}

vector< pair<int, int> > edges;

int greedy()
{
	int ans = 0;
	for (int i = m - 1; i >= 0; --i)
		for (int to : g[i])
			if (connect[to] == -1)
			{
				connect[to] = i;
				gto[i] = to;
				++ans;
				break;
			}
	return ans;
}

void solve()
{
	cin >> n;
	edges.clear();
	for (int i = 0; i < n; ++i)
	{
		int k, x;
		cin >> k;
		for (int j  = 0; j < k; ++j)
		{
			cin >> x;
			--x;
			edges.emplace_back(i, x);
		}
	}
	int m = edges.size();
	for (int i = 0; i < m; ++i)
		for (int j = 0; j < m; ++j)
			if (edges[i].second == edges[j].first)
				g[i].pb(j);
	fill(connect, connect + m, -1);
	fill(gto, gto + m, -1);
	fill(used, used + m, 0);
	int sz = greedy();
	for (int i = 0; i < m; ++i)
	{
		timer++;
		if (kuhn(i)) ++sz;
	}
	timer++;
	fill(cnt, cnt + m, 0);
	for (int i = 0; i < m; ++i)
		if (gto[i] != -1)
			cnt[gto[i]]++;
	printf("%d\n", m - sz);
	for (int i = 0; i < m; ++i)
	{
		if (cnt[i] != 0) continue;
		vector<int> cur;
		cur.pb(edges[i].first);
		for (int x = i; x != -1; x = gto[x])
			cur.pb(edges[x].second);
		for (int x : cur)
			printf("%d ", x + 1);
		printf("\n");
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
