import java.io.*;
import java.util.*;
import java.math.*;

public class M implements Runnable {
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	private void solve() throws IOException {
		int n = nextInt();
		int[][] a = new int[n][n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				a[i][j] = nextInt();
			}
		}
		int[][] result = new int[n][n];
		boolean ok = true;
		int[] ids = new int[n];
		while (true) {
			for (int i = 0; i < n; i++) {
				ids[i] = i;
			}
			//out.println("GO: ");
			boolean found = false;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (a[i][j] > 0 && ids[i] != ids[j]) {
						//out.println("MERGE: " + i + " " + j);
						found = true;
						int firstId = ids[i], secondId = ids[j];
						++result[i][j];

						for (int x = 0; x < n; x++) {
							for (int y = 0; y < n; y++) {
								if (ids[x] == firstId && ids[y] == secondId) {
									a[i][j] -= 1;
									a[j][i] -= 1;
									if (a[i][j] < 0)
										ok = false;
								}
							}
						}

						for (int k = 0; k < n; k++) {
							if (ids[k] == secondId) {
								ids[k] = firstId;
							}
						}
					}
				}
			}
			if (!found || !ok) {
				break;
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (a[i][j] != 0) {
					ok = false;
				}
			}
		}
		if (ok) {
			out.println("YES");
			int count = 0;
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (result[i][j] > 0)
						++count;
				}
			}
			out.println(count);
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (result[i][j] > 0) {
						out.println((i + 1) + " " + (j + 1) + " "
								+ result[i][j]);
					}
				}
			}
		} else {
			out.println("NO");
		}
	}

	public void run() {
		final String className = this.getClass().getName().toLowerCase();

		try {
			try {
				in = new BufferedReader(new FileReader(className + ".in"));
				out = new PrintWriter(new FileWriter(className + ".out"));
			} catch (FileNotFoundException e) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			}

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new M().run();
		// new Thread(null, new Template(), "Template", (1L << 24)).start();
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	private double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

}
