import java.io.IOException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;


public class Main {

	static boolean[] used = new boolean[20000];
	static long[] curweight = new long[20000];
	static long[] minweights = new long[20000];
	static LinkedList[] ways = new LinkedList[20000];
	static Backtrack[] from_a = new Backtrack[20000];
	
	static class Road_to {
		public int path;
		public long weight;
		public long index;
		public Road_to(int path, long weight, long index) {
			this.path = path;
			this.weight = weight;
			this.index = index;
		}
	}
	
	static class Backtrack {
		public int from;
		public long index;
		public Backtrack(int from, long index) {
			this.from = from;
			this.index = index;
		}
	}
	
	static int n;
	static long m;
	
	static void find(int from, long excl) {
		for (Object v : ways[from]) {
			if (((Road_to)v).index == excl) continue;
			int i = ((Road_to)v).path;
			if (curweight[from] + ((Road_to)v).weight < curweight[i]) {
				curweight[i] =curweight[from] + ((Road_to)v).weight;
				if (excl == -1) {
					from_a[i].from = from;
					from_a[i].index = ((Road_to)v).index;
				}
			}
		}
		used[from] = true;
		if (curweight[from] > minweights[from]) return;
		long min = Long.MAX_VALUE / 2;
		int minindex = -1;
		for (int i=0; i<n; ++i) {
			if (!used[i] && curweight[i] < min) {
				min = curweight[i];
				minindex = i;
			}
		}
		if (minindex != -1) find(minindex, excl);
	}
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(System.in);
		
		for (int i=0;i<20000;++i) ways[i] = new LinkedList();
		n = in.nextInt();
		m = in.nextInt();
		for (int i=0;i<m;++i) {
			int from = in.nextInt();
			int to = in.nextInt();
			int index = in.nextInt();
			ways[from-1].add(new Road_to(to-1, index, i));
			ways[to-1].add(new Road_to(from-1, index, i));
		}
		Arrays.fill(used, false);
		Arrays.fill(minweights, Long.MAX_VALUE / 2);
		Arrays.fill(curweight, Long.MAX_VALUE / 2);
		for (int i=0;i<n;++i) from_a[i] = new Backtrack(0,0);
		curweight[0]=0;
		find(0, -1);
		long minw = curweight[n-1];
		
		for (int i=0;i<n;++i) minweights[i] = curweight[i];
		
		LinkedList exclroads = new LinkedList();
		int ix = n-1;
		while (ix != 0) {
			exclroads.add(Long.valueOf(from_a[ix].index));
			ix = from_a[ix].from;
		}
		
		LinkedList important = new LinkedList();
		for (Object obj : exclroads) {
			long i = ((Long)obj).longValue();
			Arrays.fill(used, false);
			Arrays.fill(curweight, Long.MAX_VALUE / 2);
			curweight[0]=0;
			find(0, i);
			if (curweight[n-1] > minw) important.add(Long.valueOf(i+1));
		}
		
		System.out.println(important.size());
		for (Object i : important) {
			System.out.print(i);
			System.out.print(" ");
		}
		System.out.println();
		
		
		/*BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		char[] str = in.readLine().toCharArray();
		
		if (str.length % 2 == 0) {
			System.out.println(0);
			return;
		}
		if (str.length == 1) {
			System.out.println(1);
			return;
		}*/
		
		
		/*Scanner in = new Scanner(System.in);
		
		int n = in.nextInt();
		Graph g = new Graph(n);
		for (int i=0;i<n;++i) {
			int k = in.nextInt();
			for (int j=0;j<k;++j) {
				int to = in.nextInt();
				g.add(i, to-1);
			}
		}
		
		while (true) {
			for (int i=0;i<n;++i) {
				if (g.x2y[i].size() == 1) {
					System.out.println("-> "+i+" "+g.x2y[i].getFirst());
					g.y2x[(Integer)g.x2y[i].getFirst()] = new LinkedList();
					g.x2y[i] = new LinkedList();
					g.remove(i, (Integer)g.x2y[i].getFirst());
				}
				if (g.y2x[i].size() == 1) {
					System.out.println("<- "+g.y2x[i].getFirst()+" "+i);
					g.x2y[(Integer)g.y2x[i].getFirst()] = new LinkedList();
					g.y2x[i] = new LinkedList();
					//g.remove(i, (Integer)g.y2x[i].getFirst());
				}
			}
		}*/
		
		
		//if 
		
	}
	
	/*static class Graph {
		public int[][] mat = new int[2000][2000];
		public LinkedList[] x2y = new LinkedList[2000];
		public LinkedList[] y2x = new LinkedList[2000];
		
		public Graph(int n) {
			for (int i=0;i<n;++i) {
				x2y[i] = new LinkedList();
				y2x[i] = new LinkedList();
			}
		}
		
		public void add(int x, int y) {
			mat[x][y] = 1;
			x2y[x].add(Integer.valueOf(y));
			y2x[y].add(Integer.valueOf(x));
		}
		
		public void remove(int x, int y) {
			mat[x][y] = 0;
			x2y[x].remove(Integer.valueOf(y));
			y2x[x].remove(Integer.valueOf(x));
		}
		
	}*/
	
	/*static int check(char[] array, int start, int len) {
		if (len % 2 == 0) return 0;
		if (len == 1) return 1;
		if (array[start] != array[start+len-1]) return 0;
		int result = 0;
		for (int i=start; i<start+len; ++i) {
			if (array[i]==array[start]) {
				
			}
		}
		
	}
	
	static boolean checkPal(char[] array, int start, int len) {
		int i = start;
		int j = start+len-1;
		while (i<j) {
			if (array[i]!=array[j]) {
				return false;
			}
			++i;
			--j;
		}
		return true;
	}*/

}
