#include <iostream>
#include <vector>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)((n) - 1); i >= 0; --i)
#define fornn(i, a, b) for (int i = (int)(a); i < (int)(b); ++i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)
#define debugv(a) forn(i, a.size()) cerr << a[i] << ' '; cerr << '\n'

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;

typedef long long i64;
typedef unsigned long long u64;
typedef pair<i64, i64> pi64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;

typedef long double ld;
typedef vector<ld> vld;
typedef vector<vld> vvld;

const int MAXN = 3000;
vi e[MAXN], te[MAXN];
vector<pii> nte;
int vis[MAXN];
u64 sc[MAXN];
int up[MAXN], tin[MAXN];
int tt = 0;
int br = 0;

void dfs(int v, int p = -1) {
    if (vis[v]) return;
    tin[v] = tt++;
    up[v] = tin[v];
    vis[v] = 1;
    for (int u: e[v]) {
        if (u == p) continue;
        if (vis[u] == 1) {
            nte.pb(mp(v, u));
            up[v] = min(up[v], tin[u]);
            continue;
        }
        if (vis[u] == 0) {
            te[v].pb(u);
            dfs(u, v);
            up[v] = min(up[v], up[u]);
            if (up[u] > tin[v]) ++br;
        }
    }
    vis[v] = 2;
}

void dfst(int v, int p = -1) {
    for (int u: te[v]) {
        if (u == p) continue;
        dfst(u, v);
        sc[v] ^= sc[u];
    }
}

int main() {
    ios::sync_with_stdio(false);
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
//    freopen("output.txt", "wt", stdout);
#endif

    int N, M;
    cin >> N >> M;
    forn(i, M) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        e[x].pb(y);
        e[y].pb(x);
    }
    dfs(0);
    map<u64, int> cnt;
    for (pii p: nte) {
        u64 z = 0;
        forn(i, 64) z = 2 * z + (rand() & 1);
        sc[p.fi] ^= z;
        sc[p.se] ^= z;
        assert(cnt[z] == 0);
        ++cnt[z];
    }

    dfst(0);
    i64 ans = 0;
    forn(i, N) {
        if (!i) continue;
        u64 z = sc[i];
        ans += cnt[z]++;
    }
//    cerr << br << '\n';
    ans += 1LL * br * (M - br);
    cout << ans << '\n';

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
