#include <string>
#include <vector>
#include <bits/stdc++.h>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(v) (v).begin(), (v).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef unsigned long long u64;
typedef long double ld;

const int N = 110, infF = 110;
struct TEdge
{
    int to, cap, fl;
    TEdge(int to, int cap, int fl): to(to), cap(cap), fl(fl) {}
    TEdge() {}
};

vi g[N];
vector<TEdge> edges;
void addEdge(int from, int to, int cap)
{
    g[from].pb(edges.size());
    edges.pb(TEdge(to, cap, 0));
    g[to].pb(edges.size());
    edges.pb(TEdge(from, 0, 0));
}

bool used[N];
bool dfs(int v, int t)
{
    if (v == t) return true;
    if (used[v]) return false;
    used[v] = true;
    for (int num: g[v])
        if (edges[num].cap - edges[num].fl > 0 && dfs(edges[num].to, t))
        {
            edges[num].fl++;
            edges[num^1].fl--;
            return 1;
        }
    return 0;
}

int calcFlow(int s, int t)
{
    forn (i, t + 1) used[i] = 0;
    int r = 0;
    while (dfs(s, t)) { 
        r++; 
        forn (i, t + 1) used[i] = 0;
    }
    return r;
}

vi ans;
void prCyc(vvi& g, int v)
{
    if (g[v].size()) {
        int to = g[v].back();
        g[v].pop_back();
        prCyc(g, to);
    }
    ans.pb(v);
}

int main()
{
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    int s = 0, t = n + 1;
    int s1 = t + 1, t1 = t + 2;
    int req=0;
    for1 (i, n)
    {
        addEdge(s, i, infF);
        addEdge(i, t, infF);
        int sz;
        cin >> sz;
        forn (j, sz) {
            int v;
            cin >> v;
            addEdge(i, v, infF);
            addEdge(s1, v, 1);
            addEdge(i, t1, 1);
        }
        req += sz;
    }
    addEdge(t, s, infF);
    int l = 0, r = infF;
    while (l + 1 < r)
    {
        int mid = (l + r) / 2;
        edges[edges.size()-2].cap = mid;
        forn (i, edges.size())
            edges[i].fl = 0;
        bool ok = calcFlow(s1,t1)>=req;
        if (ok)
            r = mid;
        else
            l = mid;
    }
    edges[edges.size()-2].cap = r;
    forn (i, edges.size())
        edges[i].fl = 0;
    cout << r << endl;
    calcFlow(s1, t1);

    vvi ng(t + 1, vi());
    forn (i, s1)
    {
        for (int num: g[i])
            if (edges[num].to < s1 && edges[num].cap > 0)
            {
                int v = edges[num].to;
                forn (j, edges[num].fl)
                    ng[i].pb(v);
                if (i >= 1 && i <= n && v >= 1 && v <= n)
                    ng[i].pb(v);
            }
    }
    //forn (i, ng.size()) for (int to: ng[i]) cerr << i << " " << to << endl;
    prCyc(ng, s);
    reverse(all(ans));
    vvi res;
    for (int x: ans) 
        if (x >= 1 && x <= n)
        {
            res.back().pb(x);
        }
        else
            res.pb(vi());
    for (auto a:res)
        if (a.size())
        {
            for (int x: a)
                cout << x << " ";
            cout << endl;
        }
    return 0;
}

