#include <iostream>
#include <vector>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)((n) - 1); i >= 0; --i)
#define fornn(i, a, b) for (int i = (int)(a); i < (int)(b); ++i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)
#define debugv(a) forn(i, a.size()) cerr << a[i] << ' '; cerr << '\n'

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;

typedef long long i64;
typedef pair<i64, i64> pi64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;

typedef long double ld;
typedef vector<ld> vld;
typedef vector<vld> vvld;

struct TEdge {
    int x, y, w;

    TEdge(int x = 0, int y = 0, int w = 0)
        : x(x)
        , y(y)
        , w(w)
    {
    }

    bool operator<(const TEdge &e) const {
        return w > e.w;
    }
};

const int MAXN = 50;
vector<pii> e[MAXN];

int minEdge(int v, int p, int to) {
    if (v == to) return 1e8;
    for (pii u: e[v]) {
        if (u.fi == p) continue;
        int r = minEdge(u.fi, v, to);
        if (r < 1e9) return min(r, u.se);
    }
    return 1e9;
}

int main() {
    ios::sync_with_stdio(false);
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
//    freopen("output.txt", "wt", stdout);
#endif

    int N;
    cin >> N;
    vector<TEdge> es;
    forn(i, N) forn(j, N) {
        int x;
        cin >> x;
        if (i < j) es.pb(TEdge(i, j, x));
    }
    sort(all(es));
    bool ok = true;
    forn(i, es.size()) {
        int x = es[i].x, y = es[i].y, w = es[i].w;
        int r = minEdge(x, -1, y);
        if (r == 1e9) {
            e[x].pb(mp(y, w));
            e[y].pb(mp(x, w));
        } else ok &= r == w;
    }
    if (ok) {
        cout << "YES\n" << N - 1 << '\n';
        forn(i, N) for (auto x: e[i]) {
            if (x.fi > i) cout << i + 1 << ' ' << x.fi + 1 << ' ' << x.se << '\n';
        }
    } else {
        cout << "NO\n";
    }

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
