#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define in(x) int x=nxt()

using namespace std;

inline int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}

typedef pair <int, int> PII;
typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef long double ld;

struct edge {
    int from;
    int to;
    int u;
    int f;
};

const int M = 1000000;
const int N = 500000;
edge e[M + M];
vector <int> g[N];
int q[N];

int sz = 0;

void addEdge (int a, int b, int c) {
    edge A = edge{a, b, c, 0};
    edge B = edge{b, a, 0, 0};
    g[a].pb(sz);
    e[sz++] = A;
    g[b].pb(sz);
    e[sz++] = B;
}

int p[N];
char used[N];
int n, m;

bool bfs(int s, int t) {
    memset(used, 0, n * sizeof(char));
    int q1 = 0, q2 = 0;
    q[q1++] = s;
    used[s] = 1;
    while (q1 != q2) {
        int v = q[q2++];
        if (v == t) {
            return true;
        }
        for (int E : g[v]) {
            edge & ee = e[E];
            if (ee.f != ee.u && !used[ee.to]) {
                q[q1++] = ee.to;
                p[ee.to] = E;
                used[ee.to] = 1;
            }
        }
    }
    return false;
}

void relax(int s, int t) {
    for (int cur = t; cur != s; cur = e[p[cur]].from) {
        int E = p[cur];
        e[E].f++;
        e[E ^ 1].f--;
    }
}

bool bfs2(int s, int t) {
    memset(used, 0, n * sizeof(char));
    int q1 = 0, q2 = 0;
    q[q1++] = s;
    used[s] = 1;
    while (q1 != q2) {
        int v = q[q2++];
        if (v == t) {
            return true;
        }
        for (int E : g[v]) {
            edge & ee = e[E];
            if (ee.u > 0 && ee.f > 0 && !used[ee.to]) {
                q[q1++] = ee.to;
                p[ee.to] = E;
                used[ee.to] = 1;
            }
        }
    }
    return false;
}

vector <vector <int> > ans2;

void relax2(int s, int t) {
    vector <int> q;
    for (int cur = t; cur != s; cur = e[p[cur]].from) {
        if (cur != t) q.push_back(cur);
        int E = p[cur];
        e[E].f--;
    }
    reverse(all(q));
    ans2.push_back(q);
}

void solve() {
    in(nn); in(m); in(k); in(s); in(t);
    --s, --t;
    int flow = 0;
    int F[m], TO[m];
    for (int i = 0; i < m; ++i) {
        F[i] = nxt() - 1;
        TO[i] = nxt() - 1;
    }
    int S = 0, T = 1;
    addEdge(S, s + 2, k);
    n = nn + 2;
    #define time dshjfjsdhf
    int time = 0;
    for (time = 0; flow < k; ++time) {
        for (int i = 0; i < nn; ++i) {
            addEdge(2 + time * nn + i, 2 + time * nn + nn + i, 1e9);
        }
        addEdge(2 + time * nn + nn + t, T, 1e9);
        for (int i = 0; i < m; ++i) {
            addEdge(2 + time * nn + F[i], 2 + time * nn + nn + TO[i], 1);
            addEdge(2 + time * nn + TO[i], 2 + time * nn + nn + F[i], 1);
        }
        n += nn;
        while (bfs(S, T)) {
            ++flow;
            relax(S, T);
        }
    }

    while (bfs2(S, T)) {
        relax2(S, T);
    }
    vector <pair <int, int> > ans[time];

    for (int i = 0; i < (int)ans2.size(); ++i) {
        int tm = 0;
        for (int x = 0; x + 1 < (int)ans2[i].size(); ++x) {
            if (ans2[i][x] % nn != ans2[i][x + 1] % nn) {
                ans[x].pb(mp(i + 1, (ans2[i][x + 1] - 2) % nn + 1));
            }
        }
    }


//    for (int j = 0; j < sz; ++j) {
//        if (e[j].u == 1 && e[j].f == 1 && e[j].from != S) {
//            int tm = (e[j].from - 2) / nn;
//            ans[tm].push_back(mp((e[j].from - 2) % nn + 1, (e[j].to - 2) % nn + 1));
//        }
//    }
    cout << time << "\n";
    for (int i = 0; i < time; ++i) {
        cout << ans[i].size();
        for (auto x : ans[i]) {
            cout << " " << x.first << " " << x.second;
        }
        cout << "\n";
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    solve();
    return 0;
}
