#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define mp make_pair
#define pb push_back
#define fs first
#define sc second
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct Input {
	int n, m1, k, s, t;
	vector <pair<int, int> > e;
	
	bool read () {
		if (scanf ("%d %d %d %d %d", &n, &m1, &k, &s, &t) != 5)
			return 0;
		s--, t--;
		forn(i, m1) {
			int u, v;
			scanf ("%d %d", &u, &v);
			u--, v--;
			e.pb(mp(u, v));
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

const int N = 10010;
const int MAXD = 110;
const int inf = 1e9;

struct Data: Input {
	int ans;
	vector <pair<int, int> > ord[MAXD];
	
	void write () {
		cout << ans << endl;
		forn(i, ans) {
			printf ("%d ", (int)ord[i].size());
			forn(j, ord[i].size()) {
				printf ("%d %d ", ord[i][j].fs + 1, ord[i][j].sc + 1);
			}
			cout << endl;
		}
	}
	
	virtual void solve() {}
	virtual void clear() {}
};

struct Solution: Data {

	struct item {
		int to, c, f, pr;
		item (int To, int C, int F, int Pr) {
			to = To;
			c = C;
			f = F;
			pr = Pr;
		}
		item(){}
		int get_c() {
			return c - f;
		}
	};
	
	vector <item> a[N];
	int st, fn;
	
	void add (int u, int v, int c) {
		item k1(v, c, 0, a[v].size());
		item k2(u, 0, 0, a[u].size());
		a[u].pb(k1);
		a[v].pb(k2);
	}
	
	int d[N];
	queue<int> q;
	int p[N];
	bool use[N];
	
	bool bfs () {
		forn(i, n) {
			d[i] = inf;		
		}
		while (!q.empty())
			q.pop();
		d[st] = 0;
		q.push(st);
		while (!q.empty()) {
			int k = q.front();
			q.pop();
			forn(i, a[k].size()) {
				int to = a[k][i].to;
				if (d[to] != inf || a[k][i].get_c() <= 0)
					continue;
				d[to] = d[k] + 1;
				q.push(to);	
			}	
		}
		return d[fn] < inf;
	}
	
	int dfs (int v, int minn = inf) {
		if (v == fn)
			return minn;
		use[v] = 1;
		for (int i = p[v]; i < int(a[v].size()); ++i) {
			int to = a[v][i].to;
			if (use[to] || d[to] != d[v] + 1 || a[v][i].get_c() <= 0)
				continue;
			int k = dfs(to, min(minn, a[v][i].get_c()));
			if (k > 0) {
				a[v][i].f += k;
				a[to][a[v][i].pr].f -= k;
				return k;
			}
			p[v]++;
		}
		return 0;
	}
	
	void build (int m) {
		m++;
		st = m * n, fn = st + 1;
		forn(i, m - 1) {
			forn(j, e.size()) {
				int u = e[j].fs, v = e[j].sc;
				add(i * n + u, (i + 1) * n + v, 1);					
				add(i * n + v, (i + 1) * n + u, 1);					
			}	
		}
		forn(i, m) {
			add(st, i * n + s, inf);
			add(i * n + t, fn, inf);
		}
		n = m * n + 2;
	}
	
	int oldn;
	
	int calc (int m, bool ok = 0) {
		oldn = n;
		build(m);
		while (bfs()) {
			memset(use, 0, sizeof(use));
			memset(p, 0, sizeof(p));
			while (dfs(st) > 0)
				memset(use, 0, sizeof(use));
		}
		int res = 0;
		forn(i, a[st].size()) {
			res += a[st][i].f;
		}
		if (!ok) {
			forn(i, n)
				a[i].clear();
			n = oldn;
		}
		return res;
	}
	
	int num;
	
	bool dfsr (int v) {
		if (v == fn) {
			return 1;
		}
		int d = v / oldn - 1;
		if (v != st && v % oldn != s) {
			ord[d].pb(mp(num, v % oldn));
		}	
		forn(i, a[v].size()) {
			int to = a[v][i].to;
			if (a[v][i].f <= 0)
				continue;
			if (dfsr(to)) {
				a[v][i].f--;
				return 1;
			}	
		}
		return 0;
	}
	
	void rest () {
		forn(i, ans) {
			forn(j2, n) {	
				forn(k2, n) {
					if (j2 == k2) {
						continue;
						int j = i * oldn + j2, k = i * oldn + k2; 
						forn(j1, a[j].size()) {
							forn(k1, a[k].size()) {
								int to1 = a[j][j1].to, to2 = a[k][k1].to;
								if (a[j][j1].f != 1 || a[k][k1].f != 1 || a[j][j1].c != 1 || a[k][k1].c != 1)
									continue;					
								if (to1 == k + oldn && to2 == j + oldn) {
									a[j][j1].f = 0;
									a[k][k1].f = 0;
									add(j, j + oldn, 1);
									add(k, k + oldn, 1);
									a[j][a[j].size() - 1].f = 1;
									a[k][a[k].size() - 1].f = 1;			
								}
							}
						}
					}
				}	
			}		
		}
		num = 0;
		forn(i, ans) {
			dfsr(st);
			num++;
		}
	}
	
	void solve () {
		int l = 1, r = MAXD;
		while (l < r) {
			int m = (l + r) >> 1;
			debug(m);
			if (calc(m) < k) {
				l = m + 1;
			} else {
				r = m;
			}
		}
		calc(l, 1);
		ans = l;
		rest();		
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif

	return 0;
}
