#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define mp make_pair
#define pb push_back
#define fs first
#define sc second
#define ve vector
#define pa pair

#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 50;
struct Input {
	int n;
	int cost[N][N];
	int b[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i; j < n; ++j) {
				scanf("%d", &cost[i][j]);
			}
		}
		for (int i = 0; i < n; ++i) {
			scanf("%d", &b[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int val;
	int ans[N][N];
	
	void write () {
		printf("%d\n", val);
		for (int i = 0; i < n; ++i) {
			for (int j = i; j < n; ++j) {
				if (j != i) {
					printf(" ");
				}
				printf("%d", ans[i][j]);
			}
			printf("\n");
		}
	}
	
	virtual void solve() {}
	virtual void clear() {}
};

struct Edge {
	int u, v, c, w, f, idx;
	Edge (int u, int v, int c, int w, int f = 0, int idx = -1): u(u), v(v), c(c), w(w), f(f), idx(idx) {
	}
};

const int C = 4000 + 10;
const int CINF = 1e9;
const int WINF = 1e9;

ostream & operator << (ostream & out, Edge const & e) {
	return out << "(" << e.u << ", " << e.v << ", " << e.c << ", " << e.w << ", " << e.f << ")";
}

struct Solution: Data {
	ve<Edge> ed;
	vector<int> g[N + 3];
	
	void addEdge (int u, int v, int c, int w, int idx = -1) {
		g[u].pb(sz(ed));
		ed.pb(Edge(u, v, c, w, 0, idx));
		g[v].pb(sz(ed));
		ed.pb(Edge(v, u, 0, w, 0, -1));
	}
	
	int d[N + 3], from[N + 3];
	
	bool findPath () {
		int n = this->n + 3;
		fill(d, d + n, WINF);
		memset(from, -1, sizeof from);
		
		d[0] = 0;
		
		vector<pa<Edge, int> > e;
		for (int j = 0; j < sz(ed); ++j) {
			if (ed[j].f != ed[j].c) {
				e.pb(mp(ed[j], j));
			}
		}
		debug(e);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < sz(e); ++j) {
				if (umn(d[e[j].fs.v], d[e[j].fs.u] + e[j].fs.w)) {
					debug(e[j].fs);
					from[e[j].fs.v] = e[j].sc;
				}
			}
		}
		debug(d, d + n);
		return from[n - 1] != -1;
	}
	
	void pushFlow () {
		int v = n + 2;
		int mn = CINF;
		while (v != 0) {
			int e = from[v];
			int u = ed[e].u;
			mn = min(mn, ed[e].c - ed[e].f);
			v = u;
		}
		
		v = n + 2;
		while (v != 0) {
			int e = from[v];
			int u = ed[e].u;
			ed[e].f += mn;
			ed[e ^ 1].f -= mn;
			v = u;
		}
	}
	
	void solve () {
		addEdge(0, 1, C, 0);
		for (int i = 0; i < n; ++i) {
			addEdge(i + 1, i + 2, C - b[i], 0);
		}
		addEdge(n + 1, n + 2, C, 0);
		
		for (int i = 0; i < n; ++i) {
			for (int j = i; j < n; ++j) {	
				addEdge(i + 1, j + 2, CINF, cost[i][j], j);
			}
		}
		
		while (findPath()) {
			pushFlow();
		}
		
		memset(ans, 0, sizeof ans);
		val = 0;
		for (int i = 0; i < n; ++i) {
			for (int k = 0; k < sz(g[i + 1]); ++k) {
				int e = g[i + 1][k];
				if (ed[e].idx == -1) {
					continue;
				}
				int j = ed[e].idx;

				
//				debug(ed[e]);
				ans[i][j] = ed[e].f;
				val += ans[i][j] * cost[i][j];
			}
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;
int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("j.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
