#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
const int size = 5000;

vector <int> vertex[size];
vector <int> revs[size];
vector <int> ans[size];
int n;
bool used[size];
int clr[size];
vector <int> ts;

void topsort(int v) {
	used[v] = true;
	for (int i = 0; i < (int) vertex[v].size(); i++)
		if (!used[vertex[v][i]])
			topsort(vertex[v][i]);

	ts.pb(v);
}

void dfs(int v, int c) {
	clr[v] = c;
	for (int i = 0; i < (int) revs[v].size(); i++)
		if (clr[revs[v][i]] == -1)
			dfs(revs[v][i], c);
}

int main() {
	assert(freopen("king.in", "r", stdin));
	assert(freopen("king.out", "w", stdout));

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		int len;
		scanf("%d", &len);
		for (int j = 0; j < len; j++) {
			int d;
			scanf("%d", &d);
			d--;
			vertex[i].pb(n + d);
		}
	}
	for (int i = 0; i < n; i++) {
		int d;
		scanf("%d", &d);
		d--;
		for (int j = 0; j < (int) vertex[i].size(); j++) 
			if (vertex[i][j] == d + n) {
				swap(vertex[i][j], vertex[i].back());
				vertex[i].pop_back();
				break;
			}

		vertex[n + d].pb(i);
		ans[i].pb(d);
	}

	for (int i = 0; i < 2 * n; i++)
		used[i] = false;
	for (int i = 0; i < 2 * n; i++)
		if (!used[i])
			topsort(i);
	for (int i = 0; i < 2 * n; i++)
		for (int j = 0; j < (int) vertex[i].size(); j++)
			revs[vertex[i][j]].pb(i);

	reverse(ts.begin(), ts.end());
	for (int i = 0; i < 2 * n; i++)
		clr[i] = -1;
	int myclr = 0;
	for (int i = 0; i < (int) ts.size(); i++) {
		if (clr[ts[i]] == -1)
			dfs(ts[i], myclr++);
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < (int) vertex[i].size(); j++)
			if (clr[i] == clr[vertex[i][j]])
				ans[i].pb(vertex[i][j] - n);

	for (int i = 0; i < n; i++) {
		sort(ans[i].begin(), ans[i].end());
		printf("%d", (int) ans[i].size());
		for (int j = 0; j < (int) ans[i].size(); j++)
			printf(" %d", ans[i][j] + 1);
		printf("\n");
	}

	return 0;
}