#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
const int size = 100 * 1000;
const int ssize = 2000;

vector <pair <int, int> > vertex[ssize];

int n, m;
int v[size];
int u[size];
bool inspan[size];
vector <int> span;
bool used[ssize];
bool bridge[size];
int up[ssize];
int deep[ssize];
int banned = -1;
int hans;

void findspan(int v) {
	used[v] = true;
	for (int i = 0; i < (int) vertex[v].size(); i++)
		if (!used[vertex[v][i].fs]) {
			span.pb(vertex[v][i].sc);
			inspan[vertex[v][i].sc] = true;
			findspan(vertex[v][i].fs);
		}
}

/*
void findspan2(int v) {
	used[v] = true;
	for (int i = 0; i < (int) vertex[v].size(); i++)
		if (!used[vertex[v][i].fs] && !inspan[vertex[v][i].sc]) {
			span.pb(vertex[v][i].sc);
			inspan[vertex[v][i].sc] = true;
			findspan2(vertex[v][i].fs);
		}

}
*/

int vis;

void dfs(int v, int fr) {
	used[v] = true;
	vis++;
	up[v] = deep[v];
	
	int fst, scp;
	for (int i = 0; i < (int) vertex[v].size(); i++) {
		fst = vertex[v][i].fs;
		scp = vertex[v][i].sc;
		if (scp != fr && scp != banned) {
			if (used[fst]) {
				if (up[fst] < up[v])
					up[v] = up[fst];
				//up[v] = min(up[v], up[vertex[v][i].fs]);
				//bridge[vertex[v][i].sc] = false;
			} else {
				deep[fst] = deep[v] + 1;
				dfs(fst, scp);
				up[v] = min(up[v], up[fst]);
				bridge[scp] = deep[v] < up[fst];
				hans += bridge[scp];
			}
		}
	}

}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &v[i], &u[i]);
		v[i]--, u[i]--;

		vertex[v[i]].pb(mp(u[i], i));
		vertex[u[i]].pb(mp(v[i], i));
	}

	findspan(0);
	/*
	for (int i = 0; i < n; i++)
		used[i] = false;
	for (int i = 0; i < n; i++)
		if (!used[i])
			findspan2(0);

	for (int i = 0; i < n; i++)
		vertex[i].clear();
	for (int i = 0; i < m; i++)
		if (inspan[i]) {
			vertex[v[i]].pb(mp(u[i], i));
			vertex[u[i]].pb(mp(v[i], i));
		}
	*/

	sort(span.begin(), span.end());

	int ans = 0;
	int cnt = 0;
	for (int i = 0; i < m; i++) {
		if (inspan[i]) {
			cnt++;
			banned = i;
			/*
			for (int j = 0; j < (int) vertex[v[i]].size(); j++) {
				if (vertex[v[i]][j].sc == i) {
					swap(vertex[v[i]][j], vertex[v[i]].back());
					vertex[v[i]].pop_back();
					break;
				}
			}
			for (int j = 0; j < (int) vertex[u[i]].size(); j++) {
				if (vertex[u[i]][j].sc == i) {
					swap(vertex[u[i]][j], vertex[u[i]].back());
					vertex[u[i]].pop_back();
				}
			}
			*/
			for (int j = 0; j < n; j++)
				used[j] = false;
			memset(bridge, m, 0);
			vis = 0;
			hans = 0;
			dfs(0, -1);
			if (vis != n) {
				ans += (m - cnt);
			} else {
				ans += hans;
				for (int j = 0; j < cnt; j++)
					if (bridge[span[j]])
						ans--;
			}

			//vertex[v[i]].pb(mp(u[i], i));
			//vertex[u[i]].pb(mp(v[i], i));
		}
	}

	cout << ans << endl;
	cout << (clock() + 0.0) / CLOCKS_PER_SEC << endl;

	return 0;
}