#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
#define ADD 0
#define REMOVE 1
#define CHECK 2
const int N = (int) 3e5 + 10;
const int INF = (int) 2e9 + 2 * N;
int value[4 * N], sum[4 * N], m, n, t, l[N], r[N];
vector<int> all;

void init(int t, int l, int r) {
	if (l != r - 1) {
		int m = (l + r) / 2;
		init(t * 2 + 1, l, m);
		init(t * 2 + 2, m, r);
	}
	value[t] = INF, sum[t] = 0;
}

void add_it(int t, int l, int r, int x) {
	if (l == r - 1) {
		sum[t]++;
		value[t] = all[x] - sum[t] + 1;
		return;
	}
	int m = (l + r) / 2;
	if (x < m)
		add_it(t * 2 + 1, l, m, x);
	else
		add_it(t * 2 + 2, m, r, x);
	sum[t] = sum[t * 2 + 1] + sum[t * 2 + 2];
	value[t] = min(value[t * 2 + 1], value[t * 2 + 2] - sum[t * 2 + 1]);
}

void remove_it(int t, int l, int r, int x) {
	if (l == r - 1) {
		sum[t]--;
		value[t] = (sum[t] == 0) ? INF : (all[x] - sum[t] + 1);
		return;
	}
	int m = (l + r) / 2;
	if (x < m)
		remove_it(t * 2 + 1, l, m, x);
	else
		remove_it(t * 2 + 2, m, r, x);
	sum[t] = sum[t * 2 + 1] + sum[t * 2 + 2];
	value[t] = min(value[t * 2 + 1], value[t * 2 + 2] - sum[t * 2 + 1]);
}
int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d%d", &m, &n);
		all.clear();
		vector< pair<int, pair< int, int > > > e;
		for (int i = 0; i < n; ++i) {
			scanf("%d%d", &l[i], &r[i]);
			if ((r[i] + 1) % m == l[i]) continue;
			all.pb(l[i]), all.pb(r[i]), all.pb(r[i] + m);
		}
		if (n > m) {
			printf("NO\n");
			continue;
		}
		if (all.empty()) {
			printf("YES\n");
			continue;
		}
		sort(all.begin(), all.end());
		all.resize(unique(all.begin(), all.end()) - all.begin());
		init(0, 0, sz(all));
		for (int i = 0; i < n; ++i) {
			if ((r[i] + 1) % m == l[i]) continue;
			if (l[i] <= r[i]) {
				e.pb(mp(0, mp(ADD, r[i])));
				e.pb(mp(l[i] + 1, mp(REMOVE, r[i])));
				e.pb(mp(l[i], mp(CHECK, -1)));
				e.pb(mp(r[i] + 1, mp(ADD, r[i] + m)));
			} else {
				e.pb(mp(r[i] + 1, mp(ADD, r[i] + m)));
				e.pb(mp(l[i] + 1, mp(REMOVE, r[i] + m)));
				e.pb(mp(l[i], mp(CHECK, -1)));
			}
		}
		sort(e.begin(), e.end());
		bool bad = false;
		for (int i = 0; i < sz(e); ++i) {
			if (e[i].sc.fs == CHECK) {
				if (value[0] < e[i].fs) {
					bad = true;
					break;
				}
			} else {
				int pos = lower_bound(all.begin(), all.end(), e[i].sc.sc) - all.begin();
				((e[i].sc.fs == ADD) ? add_it : remove_it)(0, 0, sz(all), pos);
			}
		}
		printf("%s\n", bad ? "NO" : "YES");
	}
	return 0;
}