#include <cassert>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define int64 long long
#define ldb long double
const double pi = acos(-1.0);
const int size = 100;
const int inf = 1000 * 1000 * 1000;

int a[size][size];
int b[size][size];
int n;
int par[size];

int getpar(int v) {
	if (par[v] == v)
		return v;
	else
		return getpar(par[v]);
}

vector <pair <int, pair <int, int> > > ans;

vector <pair <int, int> > vertex[size];

void dfs(int v, int fr, int stv, int mx) {
	b[v][stv] = mx;
	for (int i = 0; i < (int) vertex[v].size(); i++)
		if (vertex[v][i].fs != fr)
			dfs(vertex[v][i].fs, v, stv, min(mx, vertex[v][i].sc));
}

int main() {
	assert(freopen("input.txt", "r", stdin));
	assert(freopen("output.txt", "w", stdout));

	cin >> n;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			cin >> a[i][j];
	vector <pair <int, pair <int, int> > > edges;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			edges.pb(mp(a[i][j], mp(i, j)));

	for (int i = 0; i < n; i++)
		par[i] = i;
	sort(edges.rbegin(), edges.rend());
	for (int i = 0; i < (int) edges.size(); i++) {
		int v = edges[i].sc.fs;
		int u = edges[i].sc.sc;
		v = getpar(v);
		u = getpar(u);

		if (v != u) {
			ans.pb(edges[i]);
			vertex[edges[i].sc.fs].pb(mp(edges[i].sc.sc, edges[i].fs));
			vertex[edges[i].sc.sc].pb(mp(edges[i].sc.fs, edges[i].fs));
			par[v] = u;
		}
	}

	for (int i = 0; i < n; i++)
		dfs(i, -1, i, inf);

	for (int i = 0; i < n; i++)
		b[i][i] = 0;
	bool flag = true;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			flag = flag && (a[i][j] == b[i][j]);

	if (flag) {
		printf("YES\n");
		printf("%d\n", ans.size());
		for (int i = 0; i < (int) ans.size(); i++)
			printf("%d %d %d\n", ans[i].sc.fs + 1, ans[i].sc.sc + 1, ans[i].fs);
	} else {
		printf("NO\n");
	}

	return 0;
}