#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cctype>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef long long unsigned ull;
typedef unsigned uint;
typedef pair<ll, int> pii; 

template <class T> inline T sqr(T x) { return x * x; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (b > a) a = b; }

const int maxn = 100000;
const ll inf = 1000000000000000LL; 
const int MODSIZE = 3; 
const int MODS[] = {1000000007, 1000000009, 42424243}; 

int mods[2][maxn][MODSIZE];
int sz; 
pii rmq[4 * maxn]; 
int n, m; 
vector<int> a[maxn], c[maxn]; 
vector<pii> e; 
ll d[2][maxn]; 
ll d_ans[2][maxn]; 
bool used[maxn]; 
vector<int> coste;

inline int mult(ll x, ll y, int MOD) {
	return x * y % MOD; 
}

inline void upd(int v, ll val, int cur) {
	d[cur][v] = val; 
	v += sz; 
	rmq[v] = mp(val, v - sz); 
	while (v > 1) {
		v /= 2; 
		rmq[v] = min(rmq[v * 2], rmq[v * 2 + 1]); 
	}
}

void deik(int s, int cur) {
	memset(used, 0, sizeof(used)); 
	for (int i = 0; i < sz; i++) {
		upd(i, inf, cur); 
	}
	
	upd(s, 0, cur); 
	for (int k = 0; k < MODSIZE; k++) {
		mods[cur][s][k] = 1; 
	}
	
	for (int i = 0; i < n; i++) {
		pii cur_v = rmq[1]; 
		int v = cur_v.second; 
		d_ans[cur][v] = d[cur][v]; 
		upd(v, inf, cur); 
		used[v] = 1; 
		for (int j = 0; j < a[v].size(); j++) {
			if (used[a[v][j]]) continue; 
			if (d[cur][a[v][j]] > d_ans[cur][v] + c[v][j]) {
				upd(a[v][j], d_ans[cur][v] + c[v][j], cur); 
				for (int k = 0; k < MODSIZE; k++) {
					mods[cur][a[v][j]][k] = 0; 
				}
			}
			if (d[cur][a[v][j]] == d_ans[cur][v] + c[v][j]) {
				for (int k = 0; k < MODSIZE; k++) {
					mods[cur][a[v][j]][k] += mods[cur][v][k];
					if (mods[cur][a[v][j]][k] >= MODS[k]) {
						mods[cur][a[v][j]][k] -= MODS[k]; 
					}
				}
			}
		}
	}

}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false); 

	cin >> n >> m; 

	sz = 1; 
	while (sz < n) sz *= 2; 

	for (int i = 0; i < m; i++) {
		int x, y, cost; 
		cin >> x >> y >> cost; 
		x--, y--; 
		a[x].pb(y); 
		a[y].pb(x); 
		c[x].pb(cost); 
		c[y].pb(cost); 
		e.pb(mp(x, y)); 
		coste.pb(cost); 
	}


	deik(0, 0); 
	deik(n - 1, 1); 
	
	vector<int> ans; 
	for (int i = 0; i < e.size(); i++) {
		int u = e[i].first; 
		int v = e[i].second; 
		
		bool ok = d_ans[0][u] + coste[i] + d_ans[1][v] == d_ans[0][n - 1]; 
		bool ok2 = d_ans[0][v] + coste[i] + d_ans[1][u] == d_ans[0][n - 1]; 
		for (int k = 0; k < MODSIZE; k++) {
			if (mult(mods[0][u][k], mods[1][v][k], MODS[k]) != mods[0][n - 1][k]) ok = 0; 
			if (mult(mods[0][v][k], mods[1][u][k], MODS[k]) != mods[0][n - 1][k]) ok2 = 0; 
		}

		if (ok || ok2) {
			ans.pb(i + 1); 
		}
	}

	cout << ans.size() << "\n"; 
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " "; 
	}
	cout << "\n";


	return 0;
}