#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 55;
const int M = 222;
const int E = int(1e6);

struct edge {

	int go, c, f;

};

int k = 0, s, t;
vi g[N];
pii e[M];
int q[E], used[E];
int num[N][2 * N];
vi nxt[N];
int pos[N];
edge p[E];
int next[E], pv[E], pe[E], first[E], ver[E];

inline void add(int a, int b, int c) {
	if (a == t || b == s) {
		return;
	}

	p[++k].go = b;
	p[k].c = c;
	p[k].f = 0;
	next[k] = first[a];
	first[a] = k;

	p[++k].go = a;
	p[k].c = p[k].f = 0;
	next[k] = first[b];
	first[b] = k;

	assert(k < E);
}

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK "2.in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n, m, k;
	scanf("%d %d %d %d %d", &n, &m, &k, &s, &t);
	--s;
	--t;
	for (int i = 0; i < m; ++i) {
		scanf("%d %d", &e[i].fs, &e[i].sc);
		--e[i].fs;
		--e[i].sc;
	}
	int ans = 0, flow = 0, sz = 0;
	for (int i = 0; i < n; ++i) {
		num[i][0] = sz++;
		ver[num[i][0]] = i + 1;
	}
	int f = sz++, step = 0;
	add(num[t][0], f, inf);
	for (;;) {
		++ans;
		assert(ans < 2 * N);
		for (int i = 0; i < n; ++i) {
			num[i][ans] = sz++;
			ver[num[i][ans]] = i + 1;
			add(num[i][ans - 1], num[i][ans], inf);
		}
		add(num[t][ans], f, inf);
		for (int i = 0; i < m; ++i) {
			int x = sz++, y = sz++;
			assert(sz < E);
			add(num[e[i].fs][ans - 1], x, 1);
			add(num[e[i].sc][ans - 1], x, 1);
			add(x, y, 1);
			add(y, num[e[i].fs][ans], 1);
			add(y, num[e[i].sc][ans], 1);
		}
		for (;;) {
			++step;
			used[num[s][0]] = step;
			int l = 0, r = 1;
			q[0] = num[s][0];
			while (l < r && used[f] != step) {
				int v = q[l++];
				for (int i = first[v]; i > 0 && used[f] != step; i = next[i]) {
					if (p[i].c - p[i].f > 0 && used[p[i].go] != step) {
						used[p[i].go] = step;
						pv[p[i].go] = v;
						pe[p[i].go] = i;
						q[r++] = p[i].go;
						assert(r < E);
					}
				}
			}
			if (used[f] != step) {
				break;
			}
			int can = k - flow;
			for (int i = f; i != num[s][0]; i = pv[i]) {
				can = min(can, p[pe[i]].c - p[pe[i]].f);
			}
			flow += can;
			if (can == 0) {
				break;
			}
			for (int i = f; i != num[s][0]; i = pv[i]) {
				p[pe[i]].f += can;
				if (pe[i] % 2 == 0) {
					p[pe[i] - 1].f -= can;
				} else {
					p[pe[i] = 1].f -= can;
				}
			}
		}
		if (flow == k) {
			break;
		}
	}
	for (int i = 0; i < k; ++i) {
		pos[i] = s;
	}
	printf("%d\n", ans);
	for (int i = 0; i < ans; ++i) {
		vector<pii> day;
		for (int j = 0; j < n; ++j) {
			if (j == t) {
				continue;
			}
			nxt[j].clear();
			for (int z = first[num[j][i]]; z > 0; z = next[z]) {
				if (p[z].f > 0) {
					if (p[z].go == num[j][i + 1]) {
						continue;
					}
					int z1 = p[z].go, z2 = -1;
					for (int h = first[z1]; h > 0; h = next[h]) {
						if (p[h].f > 0) {
							z2 = p[h].go;
							break;
						}
					}
					assert(z2 != -1);
					int z3 = -1;
					for (int h = first[z2]; h > 0; h = next[h]) {
						if (p[h].f > 0) {
							z3 = p[h].go;
							break;
						}
					}
					assert(z3 != -1);
					assert(ver[z3] > 0);
					if (ver[z3] - 1 != j) {
						nxt[j].pb(ver[z3] - 1);
					}
				}
			}
		}
		for (int j = 0; j < k; ++j) {
			if (sz(nxt[pos[j]]) > 0) {
				day.pb(mp(j, nxt[pos[j]].back()));
				int npos = nxt[pos[j]].back();
				nxt[pos[j]].pop_back();
				pos[j] = npos;
			}
		}
		printf("%d", sz(day));
		for (int j = 0; j < sz(day); ++j) {
			printf("  %d %d", day[j].fs + 1, day[j].sc + 1);
		}
		puts("");
	}
	return 0;
}