#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 111;

struct edge {

	int go, f, c, w;

};

int k = 0;
bool used[N];
int first[N], pv[N], pe[N], d[N];
edge p[N * N * 2];
int next[N * N * 2];
queue<int> q;
vector<vi> ans;

inline void add(int a, int b, int c, int w) {
	p[++k].go = b;
	p[k].f = 0;
	p[k].c = c;
	p[k].w = w;
	next[k] = first[a];
	first[a] = k;

	p[++k].go = a;
	p[k].c = p[k].f = 0;
	p[k].w = -w;
	next[k] = first[b];
	first[b] = k;
}

void dfs(int v) {
	used[v] = true;
	for (int i = first[v]; i > 0; i = next[i]) {
		if (p[i].f > 0 && !used[p[i].go]) {
			pv[p[i].go] = v;
			pe[p[i].go] = i;
			dfs(p[i].go);
		}
	}
}

int main() {
#ifdef LOCAL42
#define TASK "I"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n;
	scanf("%d", &n);
	int sum = 0;
	for (int i = 0; i < n; ++i) {
		int sz;
		scanf("%d", &sz);
		sum += sz;
		for (int j = 0; j < sz; ++j) {
			int num;
			scanf("%d", &num);
			--num;
			add(i, num, 1, -1);
			add(i, num, inf, 0);
		}
	}
	int s = n, t = n + 1;
	for (int i = 0; i < n; ++i) {
		add(s, i, inf, 0);
		add(i, t, inf, 0);
	}
	for (;;) {
		for (int i = 0; i <= t; ++i) {
			d[i] = inf;
			used[i] = false;
		}
		d[s] = 0;
		q.push(s);
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			used[v] = false;
			for (int i = first[v]; i > 0; i = next[i]) {
				if (p[i].c - p[i].f > 0 && d[p[i].go] > d[v] + p[i].w) {
					d[p[i].go] = d[v] + p[i].w;
					pv[p[i].go] = v;
					pe[p[i].go] = i;
					if (!used[p[i].go]) {
						used[p[i].go] = true;
						q.push(p[i].go);
					}
				}
			}
		}
		sum += d[t];
		for (int i = t; i != s; i = pv[i]) {
			++p[pe[i]].f;
			if (pe[i] % 2 == 0) {
				--p[pe[i] - 1].f;
			} else {
				--p[pe[i] + 1].f;
			}
		}
		if (sum == 0) {
			break;
		}
	}
	for (;;) {
		for (int i = 0; i <= t; ++i) {
			used[i] = false;
		}
		dfs(s);
		if (!used[t]) {
			break;
		}
		vi cur;
		for (int i = t; i != s; i = pv[i]) {
			if (i < n) {
				cur.pb(i);
			}
			--p[pe[i]].f;
		}
		reverse(all(cur));
		ans.pb(cur);
	}
	printf("%d\n", sz(ans));
	for (int i = 0; i < sz(ans); ++i) {
		for (int j = 0; j < sz(ans[i]); ++j) {
			printf("%d ", ans[i][j] + 1);
		}
		puts("");
	}
	return 0;
}
