#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const int maxn = 2000 * 100 + 10;

ll dist[maxn], dist2[maxn];
vector< pair<int, int> > g[maxn];
map< pair<int, int>, int> imap;
bool used[maxn], good[maxn];
int tin[maxn], f[maxn], timer = 0;
vector<int> answer, tt[maxn], pp[maxn];

void dfs(int v, int p = -1) {
	used[v] = true;
	tin[v] = f[v] = timer++;
	for (int i = 0; i < sz(g[v]); i++) {
		int next = g[v][i].X;

		if (p == next) continue;
		if (!good[next]) continue;

		if (sz(tt[next]) == 0) continue;
		vector<int>::iterator q = lower_bound(all(tt[next]), v);
		vector<int>::iterator qt = upper_bound(all(tt[next]), v);
		if (q == tt[next].end() || *q != v) continue;

		if (used[next]) {
			f[v] = min(f[v], tin[next]);
		} else {
			dfs(next, v);
			f[v] = min(f[v], f[next]);
			if (f[next] > tin[v] && qt - q == 1) {
				answer.pb(imap[mp(v, i)] + 1);
			}
		}
	}
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++) {
		int a, b, w;
		scanf("%d%d%d", &a, &b, &w);
		a--, b--;
		g[a].pb(mp(b, w));
		g[b].pb(mp(a, w));
		imap[mp(a, sz(g[a]) - 1)] = i;
		imap[mp(b, sz(g[b]) - 1)] = i;
	}

	for (int i = 0; i < n; i++) {
		dist[i] = INT_MAX;
		dist2[i] = INT_MAX;
	}
	dist[0] = 0;
	dist2[n - 1] = 0;

	set< pair<ll, int> > q;
	q.insert(mp(0, 0));
	while (!q.empty()) {
		pair<ll, int> top = *q.begin();
		q.erase(q.begin());
		for (int i = 0; i < sz(g[top.Y]); i++) {
			int next = g[top.Y][i].X;
			int w = g[top.Y][i].Y;
			if (dist[next] > dist[top.Y] + w) {
				q.erase(mp(dist[next], next));
				dist[next] = dist[top.Y] + w;
				pp[next].clear();
				pp[next].pb(top.Y);
				q.insert(mp(dist[next], next));
			} else {
				if (dist[next] == dist[top.Y] + w) {
					pp[next].pb(top.Y);
				}
			}
		}
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < sz(pp[i]); j++) {
			tt[i].pb(pp[i][j]);
			tt[pp[i][j]].pb(i);
		}
	}
	
	for (int i = 0; i < n; i++)
		sort(all(tt[i]));

	q.clear();
	q.insert(mp(0, n - 1));
	while (!q.empty()) {
		pair<ll, int> top = *q.begin();
		q.erase(q.begin());
		for (int i = 0; i < sz(g[top.Y]); i++) {
			int next = g[top.Y][i].X;
			int w = g[top.Y][i].Y;
			if (dist2[next] > dist2[top.Y] + w) {
				q.erase(mp(dist2[next], next));
				dist2[next] = dist2[top.Y] + w;
				q.insert(mp(dist2[next], next));
			}
		}
	}

	for (int i = 0; i < n; i++) {
		if (dist[i] + dist2[i] == dist[n - 1]) {
			good[i] = true;
		}
	}


	for (int i = 0; i < n; i++)
		if (!used[i] && good[i])
			dfs(i);
	
	printf("%d\n", sz(answer));
	sort(all(answer));
	for (int i = 0; i < sz(answer); i++)
		printf("%d ", answer[i]);
	return 0;
}