#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

vector<vector<int> > g, ng;
vector<int> order;
vector<int> used;
void dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++)
    {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
    order.pb(v);
}

int cl = 0;
vector<int> color;

void dfs2(int v)
{
    color[v] = cl;
    for (int i = 0; i < ng[v].size(); i++)
    {
        int to = ng[v][i];
        if (color[to] == -1)
            dfs2(to);
    }
}

void solve()
{
    int n;
    scanf("%d", &n);
    g.resize(n + n);
    ng.resize(n + n);
    for (int i = 0; i < n; i++)
    {
        int c;
        scanf("%d", &c);
        for (int k = 0; k < c; k++)
        {
            int x;
            scanf("%d", &x);
            x--;
            g[i].pb(n + x);
            ng[n + x].pb(i);
        }
    }
    for (int i = 0; i < n; i++)
    {
        int x;
        scanf("%d", &x);
        x--;
        g[n + x].pb(i);
        ng[i].pb(n + x);
    }
    used.assign(n + n, 0);
    for (int i = 0; i < n + n; i++)
    {
        if (!used[i])
            dfs(i);
    }
    reverse(order.begin(), order.end());
    color.resize(n + n, -1);
    for (int i = 0; i < n + n; i++)
    {
        int v = order[i];
        if (color[v] == -1)
        {
            dfs2(v);
            cl++;
        }
    }

    for (int i = 0; i < n; i++)
    {
        vector<int> ans;
        for (int k = n; k < 2 * n; k++)
        {
            if (color[k] == color[i])
                ans.pb(k - n);
        }
        cout << ans.size() << " ";
        for (int i = 0; i < ans.size(); i++)
            cout << ans[i] + 1 << " ";
        cout << endl;
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif