#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"
#define MAXN 10010
#define oo 1000000

int n, m;
double x[MAXN], y[MAXN];
vector<int> d[MAXN];
int cnt[MAXN];
double q[MAXN];

void add(int u, int v){
    d[u].push_back(v);
}

void readin(){
    cin >> n >> m;
    for (int i = 1; i <= n; i++){
        cin >> x[i] >> y[i];
    }
    int u, v;
    memset(cnt, 0, sizeof(cnt));

    for (int i = 0; i < m; i++){
        cin >> u >> v;
        u++; v++;
        add(u, v);
        add(v, u);
        cnt[u]++;
        cnt[v]++;
    }
}

double dis(int u, int v){
    double dis = sqrt((x[u] - x[v]) * (x[u] - x[v]) + (y[u] - y[v]) * (y[u] - y[v]));
    return dis;
}

double ang(int u, int v, int k){
    pair<LD, LD> vk(x[k] - x[u], y[k] - y[u]);
    pair<LD, LD> vu(x[u] - x[v], y[u] - y[v]);
    LD ang1 = atan2(vk.Y, vk.X);
    LD ang2 = atan2(vu.Y, vu.X);
    return min(2 * pi - fabs(ang1 - ang2), fabs(ang1 - ang2));
}

bool check(int i){
    int cc = 0;
    while (i != 0){
        cc += i % 2;
        i /= 2;
    }
    return cc == 2;
}

int bit(int i, int j){
    return (i >> j) % 2;
}

void init(){
    for (int u = 1; u <= n; u++){
        if (cnt[u] == 4){
            q[u] = oo;
            for (int i = 3; i < 15; i++)
                if (check(i)){
                    double calc = 0;
                    for (int iv = 0; iv < 4; iv++){
                        for (int ik = iv + 1; ik < 4; ik++)
                            if (bit(i, iv) == bit(i, ik)){
                                calc += ang(u, d[u][iv], d[u][ik]);
                            }
                    }
                    if (calc < q[u]) q[u] = calc;
                }
        } else q[u] = ang(u, d[u][0], d[u][1]);
    }
}

void solve()
{
    readin();
    init();
    double res = 0;
    for (int i = 1; i <= n; i++){
        res += q[i];
    }
    cout.setf(ios::fixed);
    cout.precision(9);
    cout << res << endl;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif