#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

vi dp;
void dinit(int n)
{
    dp.resize(n);
    forn(i, n)
        dp[i] = i;
}
int dfind(int x)
{
    return x == dp[x] ? x : dp[x] = dfind(dp[x]);
}
void dunion(int x, int y)
{
    dp[dfind(x)] = dfind(y);
}

struct edge_t
{
    int u, v, w;
    edge_t(int u, int v, int w) : u(u), v(v), w(w) {}
    friend bool operator < (const edge_t &a, const edge_t &b)
    {
        return mp(a.w, mp(a.u, a.v)) > mp(b.w, mp(b.u, b.v));
    }
};

int n;
vvi c;
vector<edge_t> res;
vector< vector<edge_t> > g;

vi used;
int dfs(int s, int t, int fl = -1)
{
    used[s] = true;
    if (s == t)
        return fl;
    forn(i, g[s].size())
    {
        int to = g[s][i].v;
        int ff = g[s][i].w;
        if (!used[to])
        {
            int res = dfs(to, t, fl == -1 ? ff : min(ff, fl));
            if (res)
                return res;
        }
    }
    return 0;
}

vvi f;

bool check()
{
    forn(i, n)
        forn(j, n)
        {
            used.assign(n, false);
            f[i][j] = dfs(i, j);
        }

    forn(i, n)
        forn(j, n)
            if (f[i][j] == -1)
                f[i][j] = 0;

    return c == f;
}

void solve()
{
    cin >> n;
    c.assign(n, vi(n));
    f.assign(n, vi(n));
    cin >> c;

    vector<edge_t> edges;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            edges.push_back(edge_t(i, j, c[i][j]));

    sort(all(edges));

    dinit(n);
    forn(i, edges.size())
    {
        int u = edges[i].u;
        int v = edges[i].v;
        if (dfind(u) != dfind(v))
        {
            dunion(u, v);
            res.push_back(edges[i]);
        }
    }

    g.resize(n);
    forn(i, res.size())
    {
        int u = res[i].u;
        int v = res[i].v;
        int w = res[i].w;
        g[u].push_back(edge_t(u, v, w));
        g[v].push_back(edge_t(v, u, w));
    }

    if (check())
    {
        cout << "YES" << endl;
        cout << res.size() << endl;
        forn(i, res.size())
            cout << res[i].u + 1 << " " << res[i].v + 1 << " " << res[i].w << endl;
    }
    else
    {
        cout << "NO" << endl;
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif